<template>
	<div>
		<v-text-field
			v-model="search"
			append-icon="mdi-magnify"
			label="Введите текст для поиска"
			single-line
			hide-details
			class="my-8"
		></v-text-field>
		<v-data-table
			:headers="headers"
			:items="landlords"
			:options.sync="options"
			:server-items-length="totalLandlords"
			:loading="loading"
			class="elevation-1"
			item-key="id"
		>
			<template v-slot:item.lanlords_read="{ item }">
				<v-simple-checkbox v-model="item.lanlords_read"></v-simple-checkbox>
			</template>
			<template v-slot:item.lanlords_write="{ item }">
				<v-simple-checkbox v-model="item.lanlords_write"></v-simple-checkbox>
			</template>
			<template v-slot:item.root="{ item }">
				<v-simple-checkbox v-model="item.root"></v-simple-checkbox>
			</template>
			<template v-slot:item.link="{ item }">
				<v-btn :to="`users/${item.id}`" icon>
					<v-icon>mdi-chevron-right</v-icon>
				</v-btn>
			</template>
		</v-data-table>
	</div>
</template>

<script>
	export default {
		name: 'BlockTableUsers',
		data () {
			return {
				expanded: [],
				search: '',
				totalLandlords: 0,
				landlords: [],
				loading: true,
				options: {},
				headers: [
					{
						text: 'ФИО',
						align: 'start',
						sortable: true,
						value: 'fio',
					},
					{ text: 'Email', value: 'email' },
					{ text: 'Чтение данных о собственниках', value: 'lanlords_read', align: 'center' },
					{ text: 'Редактирование данных о собственниках', value: 'lanlords_write', align: 'center' },
					{ text: 'Управление пользователями', value: 'root', align: 'center' },
					{ text: '', value: 'link', align: 'center', sortable: false },
				],
			}
		},
		watch: {
			options: {
				handler () {
					this.getDataFromApi()
						.then(data => {
							this.setData(data)
						})
				},
				deep: true,
			},
			search() {
				this.getDataFromApi()
					.then(data => {
						this.setData(data)
					})
			},
		},
		mounted () {
			this.getDataFromApi()
				.then(data => {
					this.setData(data)
				})
		},
		methods: {
			getDataFromApi () {
				this.loading = true
				return new Promise((resolve) => {
					const { sortBy, sortDesc, page, itemsPerPage } = this.options

					const search = this.search.trim().toLowerCase();

					let items = this.getData()
					const total = items.length

					if (search) {
						items = items.filter(item => {
							return Object.values(item)
								.join(",")
								.toLowerCase()
								.includes(search);
						});
					}

					if (sortBy.length === 1 && sortDesc.length === 1) {
						items = items.sort((a, b) => {
							const sortA = a[sortBy[0]]
							const sortB = b[sortBy[0]]

							if (sortDesc[0]) {
								if (sortA < sortB) return 1
								if (sortA > sortB) return -1
								return 0
							} else {
								if (sortA < sortB) return -1
								if (sortA > sortB) return 1
								return 0
							}
						})
					}

					if (itemsPerPage > 0) {
						items = items.slice((page - 1) * itemsPerPage, page * itemsPerPage)
					}

					setTimeout(() => {
						this.loading = false
						resolve({
							items,
							total,
						})
					}, 500)
				})
			},
			getData () {
				return [
					{
						id: 1,
						fio: 'Алексеев Алексей Алексеевич',
						email: 'alekseev@mail.ru',
						lanlords_read: true,
						lanlords_write: false,
						root: false
					},
					{
						id: 2,
						fio: 'Борисов Борис Борисович',
						email: 'borisov@mail.ru',
						lanlords_read: true,
						lanlords_write: true,
						root: true
					},
				]
			},
			setData(data) {
				this.landlords = data.items
				this.totalLandlords = data.total
			}
		},
	}
</script>

<style lang="stylus">
	.block-table-landlords
		&__footer-btns
			position absolute
</style>